"use strict";

var _require = require("../test"),
    testFn = _require.testFn,
    args = _require.args;

var _require2 = require("../index"),
    promisify = _require2.promisify;

var call = require("../index").cmds.call;

test("validator get called during unit test", function () {
  var _marked = /*#__PURE__*/regeneratorRuntime.mark(subject);

  function subject() {
    return regeneratorRuntime.wrap(function subject$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", "foo");

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _marked, this);
  }
  subject.validator = function (user) {
    if (!user) throw new Error("User required.");
  };
  try {
    testFn(subject, function () {
      return args().returns("foo");
    })();
  } catch (e) {
    expect(e.message).toEqual("User required.");
    return;
  }
  fail("testFn did not throw");
});

test("validator get called inside call function inside unit test", function () {
  var _marked2 = /*#__PURE__*/regeneratorRuntime.mark(test),
      _marked3 = /*#__PURE__*/regeneratorRuntime.mark(subject);

  var user = {};
  function test() {
    return regeneratorRuntime.wrap(function test$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return call(subject, user);

          case 2:
            return _context2.abrupt("return", _context2.sent);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _marked2, this);
  }
  function subject() {
    return regeneratorRuntime.wrap(function subject$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", "foo");

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _marked3, this);
  }
  subject.validator = function (user) {
    if (!user) throw new Error("User required.");
  };
  try {
    testFn(test, function () {
      // prettier-ignore
      return args().cmd(call(subject)).returns("foo");
    })();
  } catch (e) {
    expect(e.message).toEqual("User required.");
    return;
  }
  fail("testFn did not throw");
});

test("validator get called inside call function from inside ead function", function () {
  var _marked4 = /*#__PURE__*/regeneratorRuntime.mark(test),
      _marked5 = /*#__PURE__*/regeneratorRuntime.mark(subject);

  var user = {};
  function test() {
    return regeneratorRuntime.wrap(function test$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return call(subject);

          case 2:
            return _context4.abrupt("return", _context4.sent);

          case 3:
          case "end":
            return _context4.stop();
        }
      }
    }, _marked4, this);
  }
  function subject() {
    return regeneratorRuntime.wrap(function subject$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            return _context5.abrupt("return", "foo");

          case 1:
          case "end":
            return _context5.stop();
        }
      }
    }, _marked5, this);
  }
  subject.validator = function (user) {
    if (!user) throw new Error("User required.");
  };
  try {
    testFn(test, function () {
      // prettier-ignore
      return args().cmd(call(subject, user)).returns("foo");
    })();
  } catch (e) {
    expect(e.message.match(/expect/gi)).toBeTruthy();
    return;
  }
  fail("testFn did not throw");
});

test("validator get called during runtime", async function () {
  var _marked6 = /*#__PURE__*/regeneratorRuntime.mark(subject);

  function subject() {
    return regeneratorRuntime.wrap(function subject$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            return _context6.abrupt("return", "foo");

          case 1:
          case "end":
            return _context6.stop();
        }
      }
    }, _marked6, this);
  }
  subject.validator = function (user) {
    if (!user) throw new Error("User required.");
  };
  try {
    await promisify(subject)();
  } catch (e) {
    expect(e.message).toEqual("User required.");
    return;
  }
  fail("validator did not throw");
});
//# sourceMappingURL=validators.spec.js.map